angular.module('beamng.apps').directive('lookAheadSettings', ['bngApi', function (bngApi) {
	return {
		template:
		'<div>' +
		'	<span>Sensitivity: {{ lookaheadSensitivity }}</span><br>' +
		'	<input type="range" min="0" max="0.25" step="0.01" value="0.05" ng-model="lookaheadSensitivity"></input>' +
		'	<span>Linearity: {{ lookaheadLinearity }}</span><br>' +
		'	<input type="range" min="750" max="1750" step="10" value="1000" ng-model="lookaheadLinearity"></input>' +
		'	<input type="button" ng-click="resetSettings()" value="Reset"></input>' +
		'	<input type="checkbox" checked ng-model="reverseCamera" ng-change="changeReverseCam()" >Reverse Cam</input>' +
		'</div>',
		replace: true,
		restrict: 'EA',
		link: function (scope, element, attrs) {
			'use strict';

			bngApi.engineLua('extensions.use("bluetac_settings").getValue("lookaheadReverseCam")', function (data) {
		      scope.$evalAsync(function () {
		        scope.reverseCamera = data;
		      });
		    });

			bngApi.engineLua('extensions.use("bluetac_settings").getValue("lookaheadSensitivity")', function (data) {
		      scope.$evalAsync(function () {
		        scope.lookaheadSensitivity = data;
		      });
		    });

			bngApi.engineLua('extensions.use("bluetac_settings").getValue("lookaheadLinearity")', function (data) {
		      scope.$evalAsync(function () {
		        scope.lookaheadLinearity = data;
		      });
		    });

			scope.$on('$destroy', function () {

			});

			var lastCalledTime = Date.now();

			scope.$watch('lookaheadSensitivity', function (newVal, oldVal) {
				if(newVal !== undefined) {
					bngApi.activeObjectLua('extensions.lookAhead.changeSensitivity('+newVal+')');
				}
				//console.log("changeSensitivity", newVal, oldVal);
			});

			scope.$watch('lookaheadLinearity', function (newVal, oldVal) {
				if(newVal !== undefined) {
					bngApi.activeObjectLua('extensions.lookAhead.changeLinearity('+newVal+')');
				}
				//console.log("changeLinearity", newVal, oldVal);
			});

			scope.resetSettings = function(){
				bngApi.activeObjectLua('extensions.lookAhead.changeSensitivity(0.05)');
				bngApi.activeObjectLua('extensions.lookAhead.changeLinearity(1000)');
				scope.lookaheadSensitivity = 0.05
				scope.lookaheadLinearity = 1000;
			};

			scope.changeReverseCam = function() {
				var val = scope.reverseCamera ? true : false
				bngApi.activeObjectLua('extensions.lookAhead.toggleReverseCam('+val+')');
			}
		}
	};
}])
